#!/bin/sh

# lh_source_usb-hdd(1) - build source usb-hdd image
# Copyright (C) 2006-2008 Daniel Baumann <daniel@debian.org>
#
# live-helper comes with ABSOLUTELY NO WARRANTY; for details see COPYING.
# This is free software, and you are welcome to redistribute it
# under certain conditions; see COPYING for details.

set -e

# Including common functions
LH_BASE="${LH_BASE:-/usr/share/live-helper}"

for FUNCTION in "${LH_BASE}"/functions/*.sh
do
	. "${FUNCTION}"
done

# Setting static variables
DESCRIPTION="build source image"
HELP=""
USAGE="${PROGRAM} [--force]"

Arguments "${@}"

# Reading configuration files
Read_conffile config/common
Read_conffile config/bootstrap
Read_conffile config/chroot
Read_conffile config/binary
Read_conffile config/source
Read_conffile "${LH_CONFIG}"
Set_defaults

if [ "${LH_SOURCE}" != "enabled" ]
then
	exit 0
fi

if ! echo "${LH_SOURCE_IMAGES}" | grep -qs usb-hdd
then
        exit 0
fi

Echo_message "Begin building source usb-hdd image..."

# Requiring stage file
Require_stagefile .stage/source_debian

# Checking stage file
Check_stagefile .stage/source_usb-hdd

# Checking lock file
Check_lockfile .lock

# Creating lock file
Create_lockfile .lock

# Checking depends
Check_package chroot/sbin/mkdosfs dosfstools
Check_package chroot/sbin/parted parted

# Installing depends
Install_package

# Remove old source
if [ -f source.img ]
then
	rm -f source.img
fi

# Everything which comes here needs to be cleaned up,
DU_DIM="$(du -ms source | cut -f1)"
REAL_DIM="$(expr ${DU_DIM} + ${DU_DIM} / 50 + 1)" # Just 2% more to be sure, need something more sophistcated here...
dd if=/dev/zero of=source.img bs=1024k count=0 seek=${REAL_DIM}
FREELO="$(${LH_LOSETUP} -f)"
if [ ! -b chroot/${FREELO} ]
then
	MAKEDEV="true"

	mv chroot/dev chroot/dev.tmp
	find /dev | cpio -dmpu chroot
fi

echo "!!! The following error/warning messages can be ignored !!!"
Losetup $FREELO source.img 0
Chroot "parted -s ${FREELO} mklabel msdos" || true
Chroot "parted -s ${FREELO} mkpart primary ${LH_BINARY_FILESYSTEM} 0.0 100%" || true
Chroot "parted -s ${FREELO} set 1 lba off" || true
${LH_LOSETUP} -d ${FREELO}

Losetup $FREELO source.img 1

case "${LH_BINARY_FILESYSTEM}" in
	fat16)
		MKFS_OPTIONS="-F 16"
		;;

	fat32)
		MKFS_OPTIONS="-F 32"
		;;
esac

Chroot " mkfs.vfat ${MKFS_OPTIONS} -n DEBIAN_LIVE ${FREELO}"

mkdir -p source.tmp
${LH_ROOT_COMMAND} mount ${FREELO} source.tmp
cp -r source/* source.tmp
${LH_ROOT_COMMAND} umount source.tmp
rmdir source.tmp
${LH_LOSETUP} -d ${FREELO}
echo "!!! The above error/warning messages can be ignored !!!"

if [ -n "${MAKEDEV}" ]
then
	rm -rf chroot/dev
	mv chroot/dev.tmp chroot/dev
fi

# Removing depends
Remove_package

# Creating stage file
Create_stagefile .stage/source_usb-hdd
